/*   ScratchPad  Cache  Ver 0.00   */
/*                                   */
/*                                   */
/*   by Atsushi         2000/12/14   */


import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;


public class ScratchCacheCanvas extends Canvas
{
	/*   ---   Field   ---   */

	private Image image;

	/*   ---   Constructor   ---   */

	public ScratchCacheCanvas()
	{
		InputStream in;
	
		setSoftLabel(SOFT_KEY_1,"I");
		
		try {
			in=Connector.openInputStream("scratchpad:///0;pos=0");
			
			if (in.read()<=0)
			{
				in.close();
				cacheImage();
			}
			else
			{
				in.close();
			}
		}
		catch (IOException e) {}
		
		loadImage();
	}

	/*   ---      ---   */

	private void cacheImage()
	{
		HttpConnection connection;
		String location;
		InputStream in;
		OutputStream out;
		byte[] data;
		int length;
	
		if (IApplication.getCurrentApp().getSourceURL()!=null)
		{
			location=IApplication.getCurrentApp().getSourceURL()+"image.gif";
		}
		else
		{
			location="resource:///image.gif";
		}
		
		System.out.println("caching image \""+location+"\"");
		
		try {
			connection=(HttpConnection)(Connector.open(location,Connector.READ));
			connection.setRequestMethod(HttpConnection.GET);
			connection.setRequestProperty("Content-type","image/gif");
			connection.connect();
			in=connection.openInputStream();
			out=Connector.openOutputStream("scratchpad:///0;pos=0");
			
			data=new byte[128];
			while (true)
			{
				length=in.read(data);
				
				if (length==-1) break;
				
				out.write(data,0,length);
			}
			
			in.close();
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("can't cache image \""+location+"\"");
		}
	}

	private void loadImage()
	{
		MediaImage media;
		String location;
	
		location="scratchpad:///0;pos=0";
		
		try {
			media=MediaManager.getImage(location);
			media.use();
			image=media.getImage();
			
			if (image==null)
			{
				System.out.println("can't load image \""+location+"\"");
			}
		}
		catch (IllegalArgumentException e)
		{
			System.out.println("can't load image \""+location+"\"");
		}
		catch (ConnectionException e)
		{
			System.out.println("can't load image \""+location+"\"");
		}
	}

	/*   ---   `   ---   */

	public void paint(Graphics g)
	{
		g.lock();
		g.clearRect(0,0,getWidth(),getHeight());
		g.drawImage(image,
		    getWidth ()/2-image.getWidth ()/2,
		    getHeight()/2-image.getHeight()/2);
		g.unlock(true);
	}

	/*   ---   Cxg   ---   */

	public void processEvent(int type,int param)
	{
		if ((type==Display.KEY_PRESSED_EVENT) && (param==Display.KEY_SOFT1))
		{
			IApplication.getCurrentApp().terminate();
		}
	}
}
